#!/bin/sh
#
# installs kaptain grammar files for emboss
#

echo " This script will install EMBOSS.kaptn files."
echo " Please enter a directory in your PATH."
echo " Default is /usr/local/bin"
read targetdir
targetdir=${targetdir:-/usr/local/bin}

if [ ! -e $targetdir ]
 then
 echo " Install directory $targetdir does not exit"
 echo " Create it?  [y]"
 read create
 create=${create:-y}
 case  "$create" in
   yes | Yes | y | Y ) mkdir $targetdir;;
   * ) exit -1 ;;
 esac
 echo " Do not forget to add $targetdir to your PATH !"
 fi

if [ ! -w $targetdir ]
  then
  echo " Sorry, $targetdir is not writeable"
  exit -1
fi

targetdir=${targetdir%/}
targetdir=$targetdir/

echo " Please enter the full path to your kaptain binary"
echo " Default is /usr/bin/kaptain"
read path2kaptain
path2kaptain=${path2kaptain:-/usr/bin/kaptain}
if [ ! -e $path2kaptain ]
 then
 echo " $path2kaptain does not exist."
 echo " Please install kaptain first"
 exit -1
fi

kaptainversion=$(kaptain -version | grep Kaptain)
kaptainversion=${kaptainversion#Kaptain: 0.}

if [ $kaptainversion -lt "6" ]
  then
  echo " You have installed kaptain version 0.$kaptainversion"
  echo " Please install version 0.6 or newer first!"
  exit -1
fi



if  nc -version | grep NEdit > /dev/null
then
  echo " Found nedit client"
else
  echo " Could not find the Nedit client programm (nc)"
  echo " Maybe it is installed under a different name" 
  echo " (e.g. ncl on Mandrake) or in an unusual location?"
  echo " Please enter the (full qualified) name of your nc binary [nc]"
  read ncpath
fi

ncpath=${ncpath:-nc}


for file in $(ls *.kaptn)
do
  sed -e   s\/usr/bin/kaptain\$path2kaptain\g $file \
  | sed -e s\nc\ -\$ncpath\ -\g > $targetdir$file
  echo " installing "$targetdir$file
  chmod 755 $targetdir$file
done
 echo " "
 echo " Install EMBOSS.kaptn in the KDE K-menu? [y]"
 read inskmenu
 inskmenu=${inskmenu:-y}
 case  "$inskmenu" in
   yes | Yes | y | Y ) ;;
   * ) exit -1 ;;
 esac

echo " Where should the EMBOSS menu get installed?" 
echo " Default is $KDEDIR/share/applnk"
read kmenudir
kmenudir=${kmenudir:-$KDEDIR/share/applnk}
kmenudir=${kmenudir%/}
kmenudir=$kmenudir/

if [ ! -w $kmenudir ]
  then
  echo " Sorry, $kmenudir is not writeable"
  exit -1
fi

tar cf - EMBOSS | tar xfvC - $kmenudir

exit 0
