#!/usr/bin/perl -w

# a small utility to check the kaptn files against the emboss acd files

$acddir = "/usr/local/share/EMBOSS/acd";
$kaptndir = "/usr/local/src/EMBOSS.kaptns_0.97";

$ignore = "goutfile|svrname|auto|filter|\^ask|do\$|sbegin|send|10-signal|35-signal|\\d+|sreverse|more|fasta|osformat|[rsa]format|showall|gtitle|gsubtitle|stdout|offormat";

@acdfiles = glob("$acddir/*.acd");

foreach $acdfile (@acdfiles) {
    $acdcount=0;
	$print=1;
	@acdqualifiers="";
	open(ACDFILE,$acdfile);
	while (<ACDFILE>) {
	        if(/(groups:\s+\"[Tt]est\")|(gui:\s+\"no\")/) {
		        $print=0;
			last;
		}
		if(/(report|list|dirlist|string|selection|graph|datafile|infile|outfile|featout|sequence|seqset|seqout|seqall|seqsetall|seqoutall|float|matrix|matrixf|boolean|align|integer|codon|egexp|range|toggle|directory|outdir|seqoutset|pattern|array|discretestates|tree|frequencies|properties|distances):\s+(\w+)/) {
			$acdcount=push @acdqualifiers, $2;
		}
	} # while acdfile
	close ACDFILE;

	$acdfile =~  s/\/(\w+\/)+(\w+)\.acd/$2/;

	if($print) {
	    @kaptnqualifiers = "";
#		@kaptncount=0;
		if(open(KAPTN, "$kaptndir/$acdfile.kaptn")) {
        	while (<KAPTN>) {
		    	$line = $_;
				while ($line =~ /\s\-(\w\w+)[\s=]/g){
					$qualifier = $1;
					unless ($qualifier =~ /nohgap|norgap|nopercent/) {
						$qualifier =~ s/(no)?//;
					}
                	push @kaptnqualifiers, $qualifier unless ($qualifier =~ /$ignore/);
				} # while line
			} # while kaptnfile
			print "\n------------------\n$acdfile.acd:  ";
			foreach $acdqualifier (sort(@acdqualifiers)) {
				print "$acdqualifier ";
			}
			print "\n";
			print "$acdfile.kaptn: ";
			$old="";
			foreach $kaptnqualifier (sort(@kaptnqualifiers)) {
				print "$kaptnqualifier " unless ($kaptnqualifier eq $old);
				$old=$kaptnqualifier;
			}
			print "\n";
			close KAPTN;
		} else {
			print "#### $acdfile.kaptn is missing\n";
		}
	}	# if print
} # foreach acdfile
